<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: FAQ</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="faq">FAQ </a></h1><hr/>
<p><b>Sections:</b></p>
<ul>
<li><a class="el" href="faq.html#success">Successful installations</a></li>
<li><a class="el" href="faq.html#amd64">64-bit Linux</a></li>
<li><a class="el" href="faq.html#intelcomp">Intel compilers</a></li>
<li><a class="el" href="faq.html#macosx">Apple Macintosh running Mac OS X</a></li>
<li><a class="el" href="faq.html#optblas">Optimized BLAS libraries</a></li>
<li><a class="el" href="faq.html#debpack">Precompiled packages on Ubuntu/Debian</a></li>
<li><a class="el" href="faq.html#faq_lapack_rh9">Compiling LAPACK on RedHat9 exits with an error</a></li>
<li><a class="el" href="faq.html#faq_rh62gcc">PETSc does not compile on RedHat 6.2 with BOPT=g_c++ or BOPT=O_c++</a></li>
<li><a class="el" href="faq.html#tru64">DEC/Compaq/hp Alpha machines running OSF/1, Tru64</a></li>
<li><a class="el" href="faq.html#metissegv">magpar crashes with a segmentation violation</a></li>
<li><a class="el" href="faq.html#singleprecision">Single precision arithmetics</a></li>
<li><a class="el" href="faq.html#singleproc">Single processor version without MPI</a></li>
<li><a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a></li>
<li><a class="el" href="faq.html#mingw_compile">Compiling magpar using the MinGW compilers in Cygwin</a></li>
<li><a class="el" href="faq.html#win32_run">Running magpar on Windows</a></li>
<li><a class="el" href="faq.html#gui">Graphical User Interface for Windows</a></li>
<li><a class="el" href="faq.html#pythoninst">Installing Python</a></li>
<li><a class="el" href="faq.html#addlibs">Additional solvers and libraries for PETSc</a></li>
<li><a class="el" href="faq.html#links">Links to other FAQs, troubleshooting guides</a></li>
<li><a class="el" href="faq.html#value">What is "magpar" worth (at least ;-) ?</a></li>
<li><a class="el" href="faq.html#othersoft">Other micromagnetics software</a></li>
<li><a class="el" href="faq.html#oldlibs">Installation of old library versions</a></li>
<li><a class="el" href="faq.html#bmatsize">How does boundary matrix size scale with mesh length?</a></li>
<li><a class="el" href="faq.html#barycentric">Interpolating in a tetrahedral mesh with barycentric coordinates</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="success">
Successful installations</a></h2>
<p>Please send me an email, if you have successfully installed magpar on a system different from those listed below: magpar(at)magpar.net</p>
<table class="doxtable">
<tr>
<th>CPU </th><th>OS </th><th>magpar version </th><th><p class="starttd">comment </p>
<p class="endtd"></p>
</th></tr>
<tr>
<td>various AMD and Intel dual and quad-core processors </td><td>CentOS 4.x, 5.x<br/>
(64 bit) </td><td>0.8-0.9 </td><td>using automated installation with <a class="el" href="makefiles.html#makefiles_Makefile_libs">Makefile.libs</a>, GCC 4.2.1, and self compiled ATLAS 3.7.36 on <a class="el" href="faq.html#amd64">64-bit Linux</a>   </td></tr>
<tr>
<td>AMD Opteron Processor 250 (2 x 2.4 GHz) </td><td>Red Hat Enterprise Linux 3<br/>
(64 bit) </td><td>0.5-0.8 </td><td><a class="el" href="faq.html#amd64">64-bit Linux</a>  </td></tr>
<tr>
<td>Sun UltraSPARC IV+ </td><td>Sun Solaris 10<br/>
(64 bit) </td><td>0.8 </td><td><a href="http://www.magpar.net/InstallationOnSolarisSPARC">InstallationOnSolarisSPARC</a>  </td></tr>
<tr>
<td>AMD Athlon64 3200 </td><td>Linux <br/>
 (64 bit) </td><td>0.4 </td><td><a class="el" href="faq.html#amd64">64-bit Linux</a>  </td></tr>
<tr>
<td>Intel Xeon, AMD Athlon MP </td><td>RedHat 7.3 </td><td>0.2-0.8 </td><td>using RedHat's GNU compilers 2.96, atlas3.6.0_Linux_ATHLON and <a class="el" href="faq.html#intelcomp">Intel compilers</a>   </td></tr>
<tr>
<td>Pentium M </td><td>Debian 4.0 (etch), and Debian testing (lenny/sid) </td><td>0.1-0.9 </td><td>using atlas3.6.0_Linux_P4SSE2, GCC 4.1.3, GCC 4.2.1  </td></tr>
<tr>
<td><a href="http://en.wikipedia.org/wiki/Blue_Gene">IBM BlueGene/L</a> </td><td>Linux/custom OS </td><td>0.8pre4 </td><td>9-teraflop system; see paper by Biskeborn et al. IEEE Trans. Magn., Vol. 46, No. 3, March 2010, 880 - 885 (<a class="el" href="publications.html">Publications</a>)  </td></tr>
<tr>
<td>Pentium 4 </td><td>RedHat 9 </td><td>0.2-0.9 </td><td>using RedHat's RPM packages for LAPACK, libpng, zlib; using MPICH, because mpi++.h is missing in RedHat's LAM/MPI   </td></tr>
<tr>
<td>Apple PowerMac G5 </td><td>Mac OS X 10.4.2 w/ Xcode 2.1 </td><td>0.5 </td><td>powerpc-apple-darwin8-gcc-4.0.0 (GCC) 4.0.0 (Apple Computer, Inc. build 5026) on <a class="el" href="faq.html#macosx">Apple Macintosh running Mac OS X</a>   </td></tr>
<tr>
<td>Apple iBook G4 1.2 GHz </td><td>Mac OS X 10.3 </td><td>0.5 </td><td><a class="el" href="faq.html#macosx">Apple Macintosh running Mac OS X</a>   </td></tr>
<tr>
<td>Pentium III </td><td>Fedora Core 2 </td><td>0.3-0.5 </td><td>LAM/MPI 7.1.1  </td></tr>
<tr>
<td>Alpha EV68 </td><td>Tru64 5.1 </td><td>0.1-0.5 </td><td><a class="el" href="faq.html#tru64">DEC/Compaq/hp Alpha machines running OSF/1, Tru64</a> : using MPICH, dxml; Compaq AlphaServer SC45 V2.6 consisting of 11 ES45 nodes with 4 processors (1 GHz, 8 MB cache/CPU) each and 16 GB RAM/node, connected with Quadrics Supercomputer World high speed interconnect   </td></tr>
<tr>
<td>Alpha EV6 (21264) </td><td>Tru64 5.0A </td><td>0.1-0.3 </td><td>using MPICH, using dxml  </td></tr>
<tr>
<td>Alpha EV56 </td><td>RedHat 6.2 </td><td>0.1-0.3 </td><td>g++ is broken, compiled PETSc only with BOPT=O (no C++ support, no TAO, no energy minimization), self compiled ATLAS   </td></tr>
<tr>
<td>Alpha EV5 (21164) </td><td>Tru64 4.0F </td><td>0.1-0.3 </td><td>patching of $PETSC_DIR/src/sys/viewer/impls/mathematica necessary: replace snprintf by sprintf (see below: <a class="el" href="faq.html#tru64">DEC/Compaq/hp Alpha machines running OSF/1, Tru64</a>); using dxml   </td></tr>
<tr>
<td>AMD Athlon </td><td>RedHat 6.2 </td><td>0.1-0.3 </td><td>original RedHat C++ compiler [gcc version egcs-2.91.66 19990314/Linux (egcs-1.1.2 release)] is broken <br/>
compiled PETSc BOPT=O_c++ with g++ of gcc 3.3.1 (compiled from source) <br/>
using atlas3.4.1_Linux_ATHLON   </td></tr>
<tr>
<td>Intel Xeon 2.4 GHz </td><td>Windows XP </td><td>0.5-0.9 </td><td><p class="starttd">see below: <a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a>, <a class="el" href="faq.html#win32_run">Running magpar on Windows</a>, and <a class="el" href="faq.html#singleproc">Single processor version without MPI</a> </p>
<p class="endtd"></p>
</td></tr>
</table>
<hr/>
<h2><a class="anchor" id="amd64">
64-bit Linux</a></h2>
<p>On recent 64-bit Linux distributions, the <a class="el" href="install.html">Installation</a> instructions apply and the installation works out of the box. Still, the following suggestions might be helpful.</p>
<p><b>Problem</b></p>
<p>Compilation of magpar and all required libraries on AMD 64-bit processors (Athlon64, Opteron) running 64-bit Linux.</p>
<h3><a class="anchor" id="amd64_sol1">
Solution 1</a></h3>
<p>AMD Opteron Processor 250 (2 x 2.4 GHz) running Red Hat Enterprise Linux WS release 3 (Taroon Update 4)</p>
<p>LAPACK: The (incomplete) implementation distributed with ATLAS works: <a href="http://prdownloads.sourceforge.net/math-atlas/atlas3.6.0_Linux_HAMMER64SSE2.tar.gz?download">http://prdownloads.sourceforge.net/math-atlas/atlas3.6.0_Linux_HAMMER64SSE2.tar.gz?download</a></p>
<p>Otherwise use RedHat's LAPACK rpm "lapack-3.0-20" - also available from RPMfind: <a href="ftp://rpmfind.net/linux/redhat/enterprise/3/en/os/i386/SRPMS/lapack-3.0-20.src.rpm">ftp://rpmfind.net/linux/redhat/enterprise/3/en/os/i386/SRPMS/lapack-3.0-20.src.rpm</a> <br/>
</p>
<p>The generic LAPACK from netlib does not work!</p>
<p>Everything else works as described in the <a class="el" href="install.html">Installation</a> instructions.</p>
<h3><a class="anchor" id="amd64_sol2">
Solution 2</a></h3>
<p>submitted by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> (thanks!):</p>
<p>Good news! I've managed to get magpar running on a pure 64-bit Linux system on AMD64. It was a bit of an adventure.</p>
<p><b>ATLAS</b>: This needed to be built manually, as it looks like they've not used -fPIC (position independent code) everywhere. I needed to get the source and override (despite the warnings) the compiler flags to send -fPIC and -m64 to both the C and the Fortran components (IIRC)</p>
<p><b>LAPACK</b>: Setting the -fPIC flags and the -m64 thing does the trick, apart from at the link stage. Two files needed to be compiled manually (and then the linking done manually):</p>
<div class="fragment"><pre class="fragment">
  g77 -c -m64 -fPIC dlamch.f
  g77 -c -m64 -fPIC slamch.f
</pre></div><p>as LAPACK tries to compile these and these alone (weird) without the PIC.</p>
<p><b>MPI(CH)</b>: absolutely must have the -fPIC and the -m64 stuff in there. I think it's pretty much OK to go with:</p>
<div class="fragment"><pre class="fragment">
  CFLAGS="-fPIC -m64" FFLAGS="-fPIC -m64" RSHCOMMAND="ssh" \
  ./configure &amp;&amp; make
</pre></div><p>though watch out - if PETSc fails, then check carefully where the R_X86_64_32 relocation error occurred and (a) try and make the natural build process cover this, (b) manually build it if this fails. I guess this is true for all of them.</p>
<p><b>PETSc</b>: The above stages are necessary for PETSc 2.2.(0) - assuming everything above went to plan, then PETSc will build, but make sure the following lines in bmake/linux/variables are set:</p>
<div class="fragment"><pre class="fragment">
  C_CC            = gcc -fPIC -m64
  C_FC            = g77 -Wno-globals -fPIC -m64
  O_COPTFLAGS     = -O -Wall -Wshadow  -fomit-frame-pointer -fPIC -m64
  O_FOPTFLAGS     = -O -fPIC -m64
  CXX_CC          = g++ -fPIC -m64
  CXX_FC          = g77 -Wno-globals -fPIC -m64
  GCXX_COPTFLAGS  = -g -m64 -fPIC
  OCXX_COPTFLAGS  = -O -m64 -fPIC
  GCOMP_COPTFLAGS = -g -m64 -fPIC
  OCOMP_COPTFLAGS = -O -m64 -fPIC
</pre></div><p>Here is a suggestion for (quite pedantic ;-) compile flags for PETSc:</p>
<div class="fragment"><pre class="fragment">
  export CFLAGS="-O3 -fPIC -march=k8 -msse2 -m64 -mfpmath=sse -m3dnow
  -fexpensive-optimizations -fforce-addr -fforce-mem -finline-functions
  -funroll-loops -Wall -Winline -W -Wwrite-strings -Wno-unused"
</pre></div><p><b>zlib, libpng and magpar</b>: These should have -m64 -fPIC in their build process for consistency.</p>
<p>If all this is done, hopefully a nice static pure 64-bit binary should be built, Opteron-friendly :)</p>
<hr/>
<h2><a class="anchor" id="intelcomp">
Intel compilers</a></h2>
<p>(tested with Intel compiler (icc, ifort) version 9.0)</p>
<p>In order to compile magpar (and all the libraries) with the <a href="http://www.intel.com/cd/software/products/asmo-na/eng/compilers/284132.htm">Intel compilers</a> one can just add the following snippet to the host specific Makefile.in.$HOSTNAME or <a class="el" href="makefiles.html#makefiles_Makefile_in">Makefile.in</a> (update paths to your installation directories!) </p>
<div class="fragment"><pre class="fragment">
  CC=/usr/local/bin/icc
  CPP=/usr/local/bin/icc -E
  CXX=/usr/local/bin/icpc
  FC=/usr/local/bin/ifort
  TIMER=EXT_ETIME

  # Generate code for Intel Pentium 4 processors and enables new
  # optimizations in addition to Intel processor-specific optimizations.
  OPTFLAGS += -O3 -xN
  # http://icl.cs.utk.edu/lapack-forum/viewtopic.php?t=295
  NOOPT = -O3 -fltconsistency
  PETSC_XTRALIBS=/usr/local/lib/libifcore.a
</pre></div><p>These settings are required especially for the compilation of LAPACK (set the variables in the make.inc file) as discussed here: <a href="http://icl.cs.utk.edu/lapack-forum/viewtopic.php?t=295">http://icl.cs.utk.edu/lapack-forum/viewtopic.php?t=295</a></p>
<p>It is possible to use the precompiled ATLAS libraries, even though the <a href="http://www.intel.com/cd/software/products/asmo-na/eng/perflib/mkl/index.htm">Intel Math Kernel Library</a>, which implements all BLAS and LAPACK routines, might be a good option, too.</p>
<p>The configuration of PETSc might fail when it tests the linking of Fortran object files with mpicc. To solve this problem it is necessary to add "-lirc" to "MPI_OTHERLIBS" in mpif90.</p>
<p>If you use <a class="el" href="makefiles.html#makefiles_Makefile_libs">Makefile.libs</a> to install the libraries, it will use the settings in Makefile.in.$HOSTNAME or <a class="el" href="makefiles.html#makefiles_Makefile_in_defaults">Makefile.in.defaults</a>. If you compile by hand, define the variables above on the command line (and export them if necessary).</p>
<hr/>
<h2><a class="anchor" id="macosx">
Apple Macintosh running Mac OS X</a></h2>
<p><b>Problem</b></p>
<p>Compilation of magpar and all required libraries on Apple Macintosh running Mac OS X.</p>
<h3><a class="anchor" id="macosx_sol1">
Solution 1</a></h3>
<p>submitted by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> (thanks!)<br/>
 tested on Apple iBook G4 1.2 GHz with Mac OS X 10.3</p>
<p>I got everything up and running on Darwin/G4 [OSX to everyone else ;)]; here are a few observations.</p>
<p>1] get Fink* from SourceForge.net: <a href="http://www.finkproject.org">Fink</a> is a Debian-like package manager for Mac OS X, and contains amongst other things ATLAS and LAPACK</p>
<p>2] get ATLAS from Fink</p>
<p>3] get LAPACK from Fink</p>
<p>4] download MPICH and configure as usual I believe LAM/MPI and/or the packages from Fink might work, too.</p>
<p>5] ParMetis-3.1</p>
<ul>
<li>one should adjust the include and lib paths in ParMetis' Makefile.in to point to /sw/lib and /sw/include to pick up ATLAS and LAPACK.</li>
<li>note that on my Panther setup I needed to place /usr/include/malloc in my include path for ParMetis as malloc.h wasn't being picked up by default</li>
<li>also note that the usual /usr/lib and /usr/include should be left in the <a class="el" href="makefiles.html#makefiles_Makefile_in">Makefile.in</a></li>
</ul>
<p>6] SUNDIALS - download and configure as usual</p>
<p>7] PETSc 2.3.0</p>
<p>Copy <a class="el" href="PETSc-config-magpar_8py.html">PETSc-config-magpar.py</a> to darwin-gnu-magpar.py </p>
<div class="fragment"><pre class="fragment">
  cp PETSc-config-magpar.py darwin-gnu-magpar.py
</pre></div><p> update it (Fink installs the libraries, e.g. ATLAS, LAPACK, in /sw) and add the following line to the "configure_options": </p>
<div class="fragment"><pre class="fragment">
  '--with-cxx=g++', # mpiCC does not work (some case sensitivity issue)
</pre></div><p> Then, configure and run as usual.</p>
<p>8] TAO, zlib, and libpng as usual</p>
<h3><a class="anchor" id="macosx_sol2">
Solution 2</a></h3>
<p>submitted by <a href="http://www.parker9.com">Greg Parker</a> (thanks!)<br/>
 tested on Apple PowerMac G5 2x2.0 GHz with Mac OS X 10.4.1 w/ Xcode 2.1 and<br/>
 Apple PowerMac G5 2x2.5 GHz with Mac OS X 10.4.1 w/ Xcode 2.0</p>
<p>Turns out things are pretty easy on Tiger. No need for Fink or a Fortran compiler. Apple supplies their own BLAS/LAPACK libraries and headers, so no need for Atlas or Lapack. If they are installed, the configure system of PETSc 2.3.0 finds them by itself.</p>
<p><b>LAM/MPI</b>: Download lam-7.1.1.dmg.gz from <a href="http://www.lam-mpi.org/7.1/download.php">http://www.lam-mpi.org/7.1/download.php</a> and use the installer, which puts it in /usr/local/...</p>
<p>Then type: </p>
<div class="fragment"><pre class="fragment">
  cd $PD
  mkdir mpi
  cd mpi
  ln -s /usr/local/bin
  ln -s /usr/local/include
  ln -s /usr/local/lib
  PATH=$PD/mpi/bin:$PATH
  export PATH
  lamboot -v
</pre></div><p><b>ParMetis 3.1</b>: Edit $MAGPAR_HOME/ParMetis-3.1/Makefile.in (do not modify CC or LD variables as described here: <a class="el" href="install.html#c_metis">ParMetis</a> ) </p>
<div class="fragment"><pre class="fragment">
  # INCDIR = -I/usr/local/include -I/usr/include -I/usr/include/malloc
  # LIBDIR = -L/usr/local/lib -L/usr/lib
</pre></div><p> and compile as usual.</p>
<p><b>SUNDIALS 2.1.0</b>: Configure with the following command </p>
<div class="fragment"><pre class="fragment">
  ./configure --disable-f77 --with-mpi-incdir=$PD/mpi/include --with-mpi-libdir=$PD/mpi/lib
</pre></div><p> and compile as usual.</p>
<p><b>PETSc 2.3.0</b> </p>
<div class="fragment"><pre class="fragment">
  ./config/configure.py --with-fortran=0 --with-mpi-include=$PD/mpi/include \
    --with-clanguage=cxx --with-debugging=0 \
    --with-mpi-lib=[$PD/mpi/lib/libmpi.a,$PD/mpi/lib/liblammpi++.a,$PD/mpi/lib/liblam.a] \
    --with-cxx=mpic++ -CXXOPTFLAGS="-O3 -Wno-long-double" --with-mpirun=mpirun
  PETSC_ARCH=&lt;arch&gt; # where &lt;arch&gt; is whatever config said, e.g. darwin8.2.0
  export PETSC_ARCH
  PETSC_DIR=$PWD
  export PETSC_DIR
  make all
  make test # be sure to have X11 running first, if it fails, may have to type 'lamboot -v' again
</pre></div><p><b>libpng-1.2.5</b> </p>
<div class="fragment"><pre class="fragment">
  cp scripts/makefile.macosx ./makefile
  make # you will get errors compiling pngtest, but you can ignore them
</pre></div><p><b>Compiling magpar itself</b></p>
<p>In <a class="el" href="makefiles.html#makefiles_Makefile_in">Makefile.in</a> change the PETSc architecture to whatever PETSc's config said above </p>
<div class="fragment"><pre class="fragment">
  PETSC_ARCH = &lt;arch&gt;
  CFLAGS += -O2 -faltivec
</pre></div><hr/>
<h2><a class="anchor" id="optblas">
Optimized BLAS libraries</a></h2>
<p>It is highly recommended to use any machine specific (vendor provided and highly optimized) libraries. On most high performance machines there are optimized BLAS and LAPACK libraries available, e.g.:</p>
<ul>
<li>IBM AIX: <a href="http://publib.boulder.ibm.com/clresctr/windows/public/esslbooks.html">ESSL</a></li>
<li>DEC/Compaq Alpha: DXML, <a href="http://h20311.www2.hp.com/HPC/cache/276349-0-0-225-121.html?jumpid=reg_R1002_USEN">CXML</a></li>
<li>SUN: <a href="http://developers.sun.com/sunstudio/documentation/product/library.jsp">SUNPERF</a></li>
</ul>
<p>In addition, the following implementations are available:</p>
<ul>
<li><a href="http://math-atlas.sourceforge.net/">ATLAS</a>: Automatically Tuned Linear Algebra Software - recommended</li>
<li>Generic <a href="http://www.netlib.org/blas/index.html">BLAS</a> and <a href="http://www.netlib.org/lapack/index.html">LAPACK</a> implementations from <a href="http://www.netlib.org/">netlib</a> - portable but slow</li>
<li><a href="http://www.tacc.utexas.edu/resources/software/#blas">BLAS by Kazushige Goto</a>: Visiting Scientist, FLAME project, UT-Austin - untested</li>
<li><a href="http://www.intel.com/cd/software/products/asmo-na/eng/perflib/mkl/index.htm">Intel Math Kernel Library</a>: Optimized library for Intel <a href="http://www.intel.com/">Intel</a> processors - untested</li>
<li><a href="http://developer.amd.com/cpu/Libraries/acml">AMD Math Core Library</a>: Optimized library for <a href="http://www.amd.com/">AMD</a> processors - untested</li>
</ul>
<hr/>
<h2><a class="anchor" id="debpack">
Precompiled packages on Ubuntu/Debian</a></h2>
<p>Using Debian-based distributions (including Ubuntu) one can save a lot of time by using some of the pre-built packages.</p>
<p>The following instructions pertain specifically to Debian Lenny and were used successfully in June 2008 and saved in <a class="el" href="makefiles.html#makefiles_Makefile_in_host_debian">Makefile.in.host_debian</a>, which can serve as a template for your Makefile.in.$HOSTNAME.</p>
<p><a class="el" href="makefiles.html#makefiles_Makefile_in_host_debian">Makefile.in.host_debian</a></p>
<p>PETSc and Sundials still have to be compiled from source, since the Debian packages were built for uniprocessor systems only and do not work with MPICH. TAO also must be built from source. For this purpose one can still use the <a class="el" href="install.html#c_autoinst">Automated Installation</a> for the individual libraries like this</p>
<div class="fragment"><pre class="fragment">
  cd $MAGPAR_HOME/src
  make -f Makefile.libs sundials petsc tao
</pre></div><p>or install them using the <a class="el" href="install.html#c_maninst">Manual Installation</a> method.</p>
<p>Thanks to <a href="http://myxo.css.msu.edu/danimal/">Daniel Lenski</a> for his installation report.</p>
<hr/>
<h2><a class="anchor" id="faq_lapack_rh9">
Compiling LAPACK on RedHat9 exits with an error</a></h2>
<p><b>Problem</b></p>
<p>The GNU Fortran compiler shipping with RedHat 9 (GNU Fortran (GCC 3.2.2 20030222 (Red Hat Linux 3.2.2-5))) has problems with complex variables.</p>
<div class="fragment"><pre class="fragment">
  ...
  SEP: Testing Symmetric Eigenvalue Problem routines
  ./xeigtstc &lt; sep.in &gt; csep.out 2&gt;&amp;1
  make: *** [csep.out] Error 139
</pre></div><p>At this stage, the LAPACK library has been compiled successfully, but the complex test programs fail.</p>
<p><b>Solution</b></p>
<p>Since magpar does not use any complex variables, one can safely ignore this error message and continue with the installation.</p>
<hr/>
<h2><a class="anchor" id="faq_rh62gcc">
PETSc does not compile on RedHat 6.2 with BOPT=g_c++ or BOPT=O_c++</a></h2>
<p><b>Problem</b></p>
<p>The GNU C++ compiler shipping with RedHat 6.2 (gcc version egcs-2.91.66 19990314/Linux (egcs-1.1.2 release)) is broken and fails with an internal error:</p>
<div class="fragment"><pre class="fragment">
  libfast in: /home/scholz/work/magpar/libs/petsc-2.1.6/src/vec/esi
  eindexspace.c: In method `::esi::petsc::::esi::petsc::IndexSpace&lt;int&gt;::
  IndexSpace(class ::esi::::esi::IndexSpace&lt;int&gt; &amp;)':
  eindexspace.c:21: Internal compiler error.
  ...
</pre></div><p><b>Solution</b></p>
<p>GCC 2.95.3 (shipping with SuSE 8.0), GCC 2.95.4 (shipping with Debian 3.0 woody) and GCC 3.2.2 have proved to work. Get some binary package for your platform or compile GCC from source.</p>
<p>You can get the latest GCC release from here: <br/>
<a href="http://gcc.gnu.org/">http://gcc.gnu.org/</a> <br/>
<a href="http://gcc.gnu.org/install/binaries.html">http://gcc.gnu.org/install/binaries.html</a> <br/>
<a href="http://gcc.gnu.org/mirrors.html">http://gcc.gnu.org/mirrors.html</a></p>
<hr/>
<h2><a class="anchor" id="tru64">
DEC/Compaq/hp Alpha machines running OSF/1, Tru64</a></h2>
<h3><a class="anchor" id="tru64_ar">
Problems linking various libraries with "ar"</a></h3>
<p><b>Problem</b></p>
<p>The following error occured on a Compaq machine running Tru64 UNIX V5.1A (Rev. 1885): </p>
<div class="fragment"><pre class="fragment">
  /: write failed, file system is full
  ar:  error writing archive member contents: [...]
  *** Exit 1
  Stop.
</pre></div><p> after compiling the source files of MPICH (and ParMetis-3.1, too) when "make" tried to create the libraries using "ar".</p>
<p><b>Solution</b></p>
<p>Set the environment variable "TMPDIR" to a directory/partition with sufficent free space, e.g. your home directory: </p>
<div class="fragment"><pre class="fragment">
  TMPDIR=$HOME
  export TMPDIR
</pre></div><p> and recompile.</p>
<h3><a class="anchor" id="tru64_snprintf">
Problems with snprintf</a></h3>
<p>Tru64 version 4.x does not provide an "snprintf" function. Thus, the compilation of PETSc fails in $PETSC_DIR/src/sys/src/viewer/impls/mathematica/. A simple replacement of snprintf by sprintf and omitting the size argument solves the problem.</p>
<p>in $PETSC_DIR/src/sys/src/viewer/impls/mathematica/mathematica.c <br/>
 replace: </p>
<div class="fragment"><pre class="fragment">
  snprintf(linkname, 255, "%6d", ports[rank]);
</pre></div><p> with: </p>
<div class="fragment"><pre class="fragment">
  sprintf(linkname, "%6d", ports[rank]);
</pre></div><p> and all other occurences of snprintf in this file accordingly.</p>
<h3><a class="anchor" id="tru64_parmetis">
Compiling ParMetis</a></h3>
<p>If you are using the ELAN libraries (for Quadrics high speed interconnect) instead of MPI(CH) over Ethernet: </p>
<div class="fragment"><pre class="fragment">
  # modify $MAGPAR_HOME/src/Makefile.in to use
  # the normal C compiler instead of mpicc
  CC = cc
  XTRALIBS = -lmpi -lelan
  LD = cc
  # test example
  prun -p scp1 -n 4 -s -o out -e err ./ptest rotor.graph
</pre></div><p> Otherwise use a "normal" MPI library (MPICH, LAM/MPI) and compile as usual.</p>
<h3><a class="anchor" id="tru64_sundials21">
Compiling SUNDIALS version 2.1</a></h3>
<p>If you are using the ELAN libraries (for Quadrics high speed interconnect) instead of MPI(CH) over Ethernet: </p>
<div class="fragment"><pre class="fragment">
  # use the normal C and Fortran compilers instead of mpicc and mpif77
  ./configure --with-mpicc=cc --with-mpif77=f77
</pre></div><h3><a class="anchor" id="tru64_sundials10">
Compiling SUNDIALS version 1.0</a></h3>
<div class="fragment"><pre class="fragment">
  cd $PD/sundials

  # replace compiler "gcc" by "cc"
  # remove compiler option "-ffloat-store"
  files=`find . -name "*"`
  for i in `grep -l "CFLAGS =" $files`; do
    sed "s/gcc/cc/g" $i | sed "s/-Wall -ffloat-store//g" &gt; $i.tmp
    mv $i.tmp $i
  done

  # optional: compile with optimizations
  # (no improvement/speedup found)
  for i in `grep -r -l "CFLAGS =" $files`; do
    sed "s/CFLAGS = /CFLAGS = -O3 /g" $i &gt; $i.tmp
    mv $i.tmp $i
  done

  unset files
</pre></div><h3><a class="anchor" id="tru64_petsc230">
Compiling PETSc 2.3.0</a></h3>
<p>Install Python (if necessary) as described in the <a class="el" href="faq.html#pythoninst">Installing Python</a>.<br/>
 Modify $MAGPAR_HOME/src/PETSc-config-magpar.py: </p>
<div class="fragment"><pre class="fragment">
  ...
  # use Compaq Extended Math Library (CPML/CXML)
  '--with-blas-lib=libcxml',
  # use ELAN libraries (if you have Quadrics high speed interconnect)
  '--with-mpi-lib=libmpi.a,libelan.a',
  ...
</pre></div><p> Otherwise use a "normal" MPI library (MPICH, LAM/MPI) and compile as usual.</p>
<h3><a class="anchor" id="tru64_petsc221">
Compiling PETSc 2.2.1 and earlier</a></h3>
<div class="fragment"><pre class="fragment">
  ...
  PETSC_DIR=$PD/petsc-2.2.1
  export PETSC_DIR
  # choose suitable predefined configuration (directory name) for your platform
  PETSC_ARCH=alpha
  export PETSC_ARCH
  cd ..
  ln -s predefined/$PETSC_ARCH
  cd $PETSC_ARCH
  cp packages packages.bak
  # edit the file "packages":
  # Location of BLAS and LAPACK
  # BLASLAPACK_LIB = -ldxml
  # use ELAN libraries (if you have Quadrics high speed interconnect)
  # MPI_LIB        = -L${MPI_HOME}/lib -lmpi -lelan
  # otherwise use MPICH (as usual)
  ...
  cp petscconf.h petscconf.h.bak
  # edit petscconf.h if you want to have static binaries (recommended):
  # replace "#define PETSC_USE_DYNAMIC_LIBRARIES 1"
  # by "#undef PETSC_USE_DYNAMIC_LIBRARIES"
  # add "#define PETSC_HAVE_NETDB_H"
  # (if you really have a "netdb.h" somewhere in /usr/include)
  #
  ...
</pre></div><h3><a class="anchor" id="tru64_libpng">
Compiling libpng</a></h3>
<div class="fragment"><pre class="fragment">
  ...
  cp scripts/makefile.dec Makefile
  # edit the Makefile if necessary:
  # update the paths to zlib:
  # ZLIBLIB=../zlib-1.1.4 -lz -lm
  # ZLIBINC=../zlib-1.1.4
  make
  make test
</pre></div><h3><a class="anchor" id="tru64_magpar">
Compiling magpar</a></h3>
<p>Update <a class="el" href="makefiles.html#makefiles_Makefile_in">Makefile.in</a> if you are using PETSc 2.2.1 or earlier: </p>
<div class="fragment"><pre class="fragment">
  ...
  # set the proper PETSC_ARCH (which was used for compiling PETSc):
  # PETSC_ARCH  = alpha
  # link statically:
  # CLINKER_STATIC = -non_shared
  # optional: really tough checking with Tru64's cc:
  # CFLAGS     += -portable -check -verbose
  ...
</pre></div><hr/>
<h2><a class="anchor" id="metissegv">
magpar crashes with a segmentation violation</a></h2>
<p><b>Problem</b></p>
<p>This segmentation fault might happen during mesh refinement, mesh partitioning (or really just the first call to a METIS function). In <a class="el" href="parteleser_8c.html">parteleser.c</a>, for example, METIS_MeshToDual is called to convert the mesh into its dual graph and obtain the adjacency structure of the mesh. If you happen to have a very weird mesh in which many elements share a single node, some static arrays in Metis are too small.</p>
<p><b>Solution</b></p>
<p>You can either generate a better mesh (if this problem occurs many elements are terribly degenerate with high aspect ratio and low quality factor anyway) or patch METIS:</p>
<p>Edit $PD/ParMetis-3.1.1/METISLib/mesh.c:79 and increase the array size: </p>
<div class="fragment"><pre class="fragment">
  idxtype *mark, ind[500], wgt[500];
</pre></div><p> Then you have to recompile the ParMetis package and recompile magpar: </p>
<div class="fragment"><pre class="fragment">
  cd $PD/ParMetis-3.1.1/
  make
  cd $MAGPAR_HOME/src/
  # remove the magpar binary, so a new one is linked
  rm magpar.exe
  make
</pre></div><hr/>
<h2><a class="anchor" id="singleprecision">
Single precision arithmetics</a></h2>
<p>NB: magpar does not appear to work in single precision mode at all right now! There seem to be big problems with the KSP and TAO solvers (convergence issues!?).</p>
<p>To compile magpar with single precision floating point arithmetics:</p>
<p>set floating point precision in Makefile.in.$HOSTNAME </p>
<div class="fragment"><pre class="fragment">
  PRECISION=single
</pre></div><p>patch TAO to make it compile with PETSc in single precision (patch not available yet)</p>
<p>recompile PETSc, Sundials, TAO </p>
<div class="fragment"><pre class="fragment">
  make -f Makefile.libs petsc tao sundials
</pre></div><p>recompile magpar </p>
<div class="fragment"><pre class="fragment">
  make
</pre></div><hr/>
<h2><a class="anchor" id="singleproc">
Single processor version without MPI</a></h2>
<p>Compile magpar according to the <a class="el" href="install.html">Installation</a> instructions with the following modifications:</p>
<h3><a class="anchor" id="singleproc_parmetis">
ParMetis</a></h3>
<p>In $PD/ParMetis-3.1.1/METISLib/metis.h remove line 25: </p>
<div class="fragment"><pre class="fragment">
  #include "../parmetis.h"  /* Get the idxtype definition */
</pre></div><p>Compile serial version only: </p>
<div class="fragment"><pre class="fragment">
  cd METISLib
  make CC=gcc LD=gcc
</pre></div><p>Do not use Metis-4.0.1 (November 1998), because it contains a couple of bugs, which have been ironed out in the Metis version included in ParMetis!</p>
<h3><a class="anchor" id="singleproc_sundials">
SUNDIALS</a></h3>
<div class="fragment"><pre class="fragment">
  ./configure --prefix=$PWD --disable-mpi
  make
  make -i install
</pre></div><h3><a class="anchor" id="singleproc_petsc">
PETSc</a></h3>
<p>modify $MAGPAR_HOME/src/PETSc-config-magpar.py:<br/>
 comment out all MPI related lines except for: </p>
<div class="fragment"><pre class="fragment">
  '--with-mpi=0',
</pre></div><p> Then configure and compile as usual.</p>
<hr/>
<h2><a class="anchor" id="win32_compile">
Compiling magpar in Cygwin for Windows</a></h2>
<p>Here is a recipe for compiling magpar in the Cygwin environment on a Windows machine:</p>
<ul>
<li>get Cygwin: <a href="http://cygwin.com/">http://cygwin.com/</a></li>
<li>download the setup program <a href="http://cygwin.com/setup.exe">http://cygwin.com/setup.exe</a> and run it</li>
<li>not all packages are required - here is an overview of recommended packages: <div class="fragment"><pre class="fragment">
  Category     Package
  ------------------------------------------------
  Admin        none
  Archive      none
  Audio        none
  Base         all
  Database     none
  Devel        binutils, gcc, gcc-core, gcc-g++, gcc-g77, gcc-mingw-*, make
  Doc          none (recommended: cygwin-doc, man)
  Editors      none
  Games        none
  Gnome        none
  Graphics     libpng12*
  Interpreters gawk, python, perl
  Libs         zlib
  Mail         none
  Math         lapack
  Mingw        none
  Net          none
  Publishing   none
  Shells       bash, (recommended: mc)
  Text         less
  Utils        bzip2, cygutils, diffutils (required by PETSc)
  Web          wget
  X11          none
</pre></div></li>
</ul>
<p>In <a class="el" href="makefiles.html#makefiles_Makefile_in_defaults">Makefile.in.defaults</a> or your own Makefile.in.$HOSTNAME set </p>
<div class="fragment"><pre class="fragment">
  ATLAS_DIR=/usr/lib
</pre></div><p> to use Cygwin's LAPACK.</p>
<p>Follow the general <a class="el" href="install.html">Installation</a> instructions and those for <a class="el" href="faq.html#singleproc">Single processor version without MPI</a>. If magpar is compiled in the Cygwin environment, magpar will generate complete inp files (cf. <a class="el" href="output.html#project_inp_inp">project.INP.inp</a>).</p>
<p>In addition, users have reported successful parallel magpar installations/runs with MPICH in the Cygwin environment:</p>
<ul>
<li>Download and install the <a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=200b2fd9-ae1a-4a14-984d-389c36f85647&amp;displaylang=en">Microsoft Visual C++ 2005 SP1 Redistributable Package</a> (required by MPICH Windows binary packages).</li>
<li>Download and install a suitable MPICH Windows binary package (*.msi) from the <a href="http://www.mcs.anl.gov/research/projects/mpich2/downloads/index.php?s=downloads">MPICH2 Downloads</a> page.</li>
<li>Update the MPI_DIR variable in your magpar Makefile.in.$HOST or <a class="el" href="makefiles.html#makefiles_Makefile_in_defaults">Makefile.in.defaults</a> to the MPICH2 installation directory, e.g. "C:\Program Files\MPICH2\".</li>
<li>Follow the general instructions for compilation in Cygwin above.</li>
<li>Run a magpar example with 2 magpar processes on the local machine (e.g. a dual core processor) with a command like this: <div class="fragment"><pre class="fragment">mpiexec.exe -n 2 -localonly ./magpar.exe </pre></div></li>
<li>Running parallel magpar processes on remote machines should only be a matter of a proper MPICH2 network installation. This requires the installation of MPDs (MPICH daemons) as a service on the remote machines.</li>
</ul>
<p>magpar executables for Windows and the source code of all required libraries are available on the <a href="http://www.magpar.net/">magpar homepage</a>.</p>
<hr/>
<h2><a class="anchor" id="mingw_compile">
Compiling magpar using the MinGW compilers in Cygwin</a></h2>
<p>This section describes the procedure for compiling magpar using the MinGW compilers in the Cygwin environment on a Windows machine. The advantage over compilation with the native Cygwin compilers is, that the MinGW compiled executables do not require the cygwin.dll any more and the other libraries (see <a class="el" href="faq.html#win32_run">Running magpar on Windows</a>) are linked statically into the executable. Compilation in the native MinGW/MSYS environment does not work (easily), because of PETSc using Python for its configuration.</p>
<p>Currently, the Windows version of magpar has only been compiled and tested in serial model (without MPI support). Thus, the installation procedure described in <a class="el" href="faq.html#singleproc">Single processor version without MPI</a> should be used with the following modifications:</p>
<p>Install Cygwin as described in <a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a> with the addition of packages of the MinGW compilers (included in category "Devel"). The package names are gcc-mingw, gcc-mingw-core, gcc-mingw-g++, gcc-mingw, gcc-mingw-g77.</p>
<p>Compile the required libraries with the following changes (the most important being the addition of the "-mno-cygwin" option for the compilers):</p>
<p>The following steps are automated in the following targets in Makefile.libs :</p>
<ul>
<li>lapack_mingw</li>
<li>parmetis_mingw</li>
<li>sundials_mingw</li>
<li>petsc_mingw</li>
<li>zlib_mingw</li>
<li>libpng_mingw</li>
</ul>
<p>BLAS/LAPACK: </p>
<div class="fragment"><pre class="fragment">
  cp make.inc.example make.inc
  # generate BLAS and LAPACK libraries (no optimized BLAS for now)
  make FORTRAN=g77 LOADER=g77 TIMER=EXT_ETIME OPTS="-funroll-all-loops -O3 -mno-cygwin" blaslib lapacklib
  cp blas_LINUX.a libblas.a
  cp lapack_LINUX.a liblapack.a
</pre></div><p>ParMetis: </p>
<div class="fragment"><pre class="fragment">
  make CC=gcc LD=gcc CFLAGS="-O3 -I. -mno-cygwin"
</pre></div><p>Sundials: </p>
<div class="fragment"><pre class="fragment">
  ./configure --prefix=$PWD --disable-mpi --with-cflags=-mno-cygwin --with-ldflags=-mno-cygwin
</pre></div><p>PETSc: </p>
<div class="fragment"><pre class="fragment">
  cd $PETSC_DIR
  export PRECISION=double
  export OPTFLAGS="-mno-cygwin"
  export ATLAS_DIR=/usr/lib
  export PETSC_XTRALIBS=""
  ./config/PETSc-config-magpar.py
</pre></div><p>After running ./config/PETSc-config-magpar.py remove the following flags from $PETSC_DIR/PETSc-config-magpar/include/petscconf.h (or $PETSC_DIR/bmake/PETSc-config-magpar/petscconf.h for PETSc 2.3.x): </p>
<div class="fragment"><pre class="fragment">
  PETSC_HAVE_GETPAGESIZE
  PETSC_HAVE_IEEEFP_H
  PETSC_HAVE_NETDB_H
  PETSC_HAVE_PWD_H
  PETSC_HAVE_SYS_PROCFS_H
  PETSC_HAVE_SYS_RESOURCE_H
  PETSC_HAVE_SYS_TIMES_H
  PETSC_HAVE_SYS_UTSNAME_H
</pre></div><p> simple sed script: </p>
<div class="fragment"><pre class="fragment">
	hfile=bmake/PETSc-config-magpar/petscconf.h; \
	cp $hfile $hfile.bak; \
	cat $hfile.bak | \
	sed "/PETSC_HAVE_GETPAGESIZE/,+2 d" | \
	sed "/PETSC_HAVE_NETDB_H/,+2 d" | \
	sed "/PETSC_HAVE_PWD_H/,+2 d" | \
	sed "/PETSC_HAVE_SYS_PROCFS_H/,+2 d" | \
	sed "/PETSC_HAVE_SYS_RESOURCE_H/,+2 d" | \
	sed "/PETSC_HAVE_SYS_TIMES_H/,+2 d" | \
	sed "/PETSC_HAVE_SYS_UTSNAME_H/,+2 d" \
	&gt; $hfile
</pre></div><p>zlib: </p>
<div class="fragment"><pre class="fragment">
  make CFLAGS="-O -mno-cygwin"
</pre></div><p>libpng: </p>
<div class="fragment"><pre class="fragment">
  # make sure $PD is set correctly
  lib=libpng-1.2.33  # adjust to your version of libpng
  zlib=zlib-1.2.3    # adjust to your version of zlib
  ./configure --prefix=$PD/$lib --enable-shared=no CFLAGS="-I$PD/$zlib -mno-cygwin" LDFLAGS="-L$PD/$zlib -mno-cygwin" 2&gt;&amp;1 | tee configure.log
  make &amp;&amp; make install &amp;&amp; make check
</pre></div><p>magpar: </p>
<div class="fragment"><pre class="fragment">
  # a simple "make" will compile and link the magpar executable
  make
</pre></div><p>After compiling magpar (or really any program) one can check which DLLs the program depends on using </p>
<div class="fragment"><pre class="fragment">
  objdump -p magpar.exe
</pre></div><p>see also: <a href="http://www.delorie.com/howto/cygwin/mno-cygwin-howto.html">http://www.delorie.com/howto/cygwin/mno-cygwin-howto.html</a></p>
<hr/>
<h2><a class="anchor" id="win32_run">
Running magpar on Windows</a></h2>
<p>To run magpar on Windows either check <a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a> or download the archives containing the precompiled binaries from the <a href="http://www.magpar.net/DownloadPage">magpar download page</a>.</p>
<p>One zip archive contains the (executable) program itself and the required libraries:</p>
<ul>
<li>magpar.exe: magpar executable</li>
<li>cygwin1.dll: Cygwin library</li>
<li>cygblas.dll: BLAS library</li>
<li>cyglapack.dll: LAPACK library</li>
<li>cygpng12.dll: PNG library</li>
<li>cygz.dll: zlib library</li>
</ul>
<p>To run a magpar simulation</p>
<ul>
<li>extract the files from the archive</li>
<li>copy the magpar executable into a simulation directory (e.g. one of the examples provided separately)</li>
<li>copy the DLLs to C:\Windows\ (once) or also into each simulation directory</li>
<li>double click on magpar.exe in the simulation directory</li>
<li>or run the executable in a "Command Prompt" window (select "Start/Programs/Accessories/Command Prompt" or do "Run.../cmd").</li>
<li>ideally run the executable in a "Command Prompt" like this "./magpar.exe &gt; stdout.txt" so the informational output of magpar is saved in the file stdout.txt. Then inspect the file stdout.txt as the simulation runs (e.g. with WordPad - not Notepad due to Unix newlines)</li>
</ul>
<p>The precompiled magpar executable provided</p>
<ul>
<li>is only a serial version (it does not support parallelization on SMP machines or clusters)</li>
<li>generates complete <a class="el" href="output.html#project_inp_inp">project.INP.inp</a> files</li>
<li>calculates exchange field and energy separately from anisotropy</li>
<li>includes K_2 in the uniaxial and cubic anisotropy field and energy</li>
</ul>
<hr/>
<h2><a class="anchor" id="gui">
Graphical User Interface for Windows</a></h2>
<p>The Windows executables of magpar are simple programs which just run in a terminal window without any nice user interface. However, thanks to the work of <a href="http://tblachow-magmain.bobolin.com.pl/" target="_top">Tomasz Blachowicz</a> and Bartlomiej Baron there is now also a nice graphical user interface for magpar available (see Tomasz's webpage).</p>
<p>Here is a quick introduction how to use it:</p>
<ol type="1">
<li>Download MagParExt from its <a href="http://tblachow-magmain.bobolin.com.pl/magparext.html">homepage</a> and install it.</li>
<li>Copy magpar.exe and the DLLs into a project (e.g. example) directory</li>
<li>Launch MagParExt</li>
<li>assign a new name to your project (independent of the magpar project/simName)</li>
<li>Point MagParExt to the project directory using the "Project files/Browse..." button</li>
<li>Check/modify the simulation parameters using the "Simulation/Configure..." button</li>
<li>Check/modify the material parameters using the "Materials/Configure..." button</li>
<li>Configure the application path to magpar.exe using "Options/General"</li>
<li>If a copy of the Cygwin DLLs is installed in "C:\Windows" there is no need to copy them into each project diretory.</li>
<li>Run the simulation using the "Simulation/Run" button</li>
<li>When the simulation finishes import the output data using the "Output data/Import from file..." button (make sure you open the *.log file in the correct directory)</li>
<li>Click on "Output data/Preview" to have a look at the log file</li>
<li>Visualize the results using "Graphs"</li>
<li>Add "Add new graph..." and assign a name to the graph</li>
<li>Set up "Data Series" by selecting data for x- and y-axis and click "Add"</li>
<li>Click "Ok" to view the plot</li>
<li>Go to "Animations" and press play to view them.</li>
</ol>
<p>References:<br/>
 See the paper by Tomasz Blachowicz and Bartlomiej Baron in the list of <a class="el" href="publications.html">Publications</a> and online at <a href="http://arxiv.org/abs/0807.2655">[ arXiv ]</a>.</p>
<hr/>
<h2><a class="anchor" id="pythoninst">
Installing Python</a></h2>
<p>If you do not have Python installed on your system or your Python version is older than 2.2. then download the latest source package of <a href="http://www.python.org">Python</a>, configure, compile, and install it with </p>
<div class="fragment"><pre class="fragment">
  ./configure --prefix=$PD/python
  make
  make install
</pre></div><p>and update $MAGPAR_HOME/src/PETSc-config-magpar.py with the full path to the python binary, e.g. </p>
<div class="fragment"><pre class="fragment">
  #!/home/scholz/work/magpar/libs/python/bin/python
</pre></div><p> (the environment variable "$MAGPAR_HOME" does not work here!)</p>
<hr/>
<h2><a class="anchor" id="addlibs">
Additional solvers and libraries for PETSc</a></h2>
<p>These libraries are optional and they make additional preconditioners/linear solvers available to PETSc. They are not required for magpar. <br/>
 Please consult the PETSc manual on how to make use of these additional solvers.</p>
<h3><a class="anchor" id="addlibs_hypre">
hypre</a></h3>
<p>This library is optional and makes additional preconditioners/linear solvers available to PETSc. It is not required for magpar. <br/>
 Please consult the PETSc manual on how to make use of these additional solvers.</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  wget http://www.llnl.gov/CASC/hypre/download/hypre-1.8.2b.tar.gz
  tar xzvf hypre-1.8.2b.tar.gz
  cd hypre-1.8.2b/src
  # for MPICH
  ./configure --with-mpi-include=${MAGPAR_HOME}/libs/mpich/include \
              --with-mpi-libs="mpich pmpich fmpich" \
              --with-mpi-lib-dirs=${MAGPAR_HOME}/libs/mpich/lib \
              --with-blas="-I${MAGPAR_HOME}/libs/atlas/include \
              -L${MAGPAR_HOME}/libs/atlas/lib -llapack -lf77blas -latlas -lg2c"
  # for LAM/MPI
  ./configure --with-mpi-include=${MAGPAR_HOME}/libs/lam/include \
              --with-mpi-libs="mpi lamf77mpi lam" \
              --with-mpi-lib-dirs=${MAGPAR_HOME}/libs/lam/lib \
              --with-blas="-I${MAGPAR_HOME}/libs/atlas/include \
              -L${MAGPAR_HOME}/libs/atlas/lib -llapack -lf77blas -latlas -lg2c"
  # fix utilities/fortran.h (remove one underscore at end of line)
  # line 31: define hypre_NAME_C_CALLING_FORT(name,NAME) name##_
  # line 32: define hypre_NAME_FORT_CALLING_C(name,NAME) name##_
  make
</pre></div><h3><a class="anchor" id="addlibs_superlu">
SuperLU</a></h3>
<p>This library is optional and makes additional preconditioners/linear solvers available to PETSc. It is not required for magpar. <br/>
 Please consult the PETSc manual on how to make use of these additional solvers.</p>
<div class="fragment"><pre class="fragment">
  cd $PD
  wget http://crd.lbl.gov/~xiaoye/SuperLU/superlu_dist_2.0.tar.gz
  tar xzvf superlu_dist_2.0.tar.gz
  cd SuperLU_DIST_2.0
  # edit make.inc:
  # PLAT            = _linux
  # DSuperLUroot    = ${MAGPAR_HOME}/libs/SuperLU_DIST_2.0
  # BLASLIB         = -L${MAGPAR_HOME}/libs/atlas/lib -llapack -lf77blas -latlas -lg2c
  # for MPICH
  # MPILIB          = -L${MAGPAR_HOME}/libs/mpi/lib -lmpich -lpmpich
  # for LAM/MPI
  # MPILIB          = -L${MAGPAR_HOME}/libs/mpi/lib -lmpi -llamf77mpi -llam
  # CC              = ${MAGPAR_HOME}/libs/mpi/bin/mpicc
  # CFLAGS          = -O3
  # FORTRAN         = ${MAGPAR_HOME}/libs/mpi/bin/mpif77
  # FFLAGS          = -O3
  # LOADER          = ${MAGPAR_HOME}/libs/mpi/bin/mpicc
  # LOADOPTS        = #
  # CDEFS           = -DAdd_
</pre></div><hr/>
<h2><a class="anchor" id="links">
Links to other FAQs, troubleshooting guides</a></h2>
<p>An extensive list of known problems and difficulties is listed on the PETSc website: <br/>
<a href="http://www.mcs.anl.gov/petsc/petsc-as/documentation/troubleshooting.html">http://www.mcs.anl.gov/petsc/petsc-as/documentation/troubleshooting.html</a> <br/>
<a href="http://www.mcs.anl.gov/petsc/petsc-as/documentation/faq.html">http://www.mcs.anl.gov/petsc/petsc-as/documentation/faq.html</a></p>
<hr/>
<h2><a class="anchor" id="value">
What is "magpar" worth (at least ;-) ?</a></h2>
<div class="fragment"><pre class="fragment">
Total Physical Source Lines of Code (SLOC)                = 11,632
Development Effort Estimate, Person-Years (Person-Months) = 2.63 (31.56)
 (Basic COCOMO model, Person-Months = 2.4 * (KSLOC**1.05))
Schedule Estimate, Years (Months)                         = 0.77 (9.28)
 (Basic COCOMO model, Months = 2.5 * (person-months**0.38))
Estimated Average Number of Developers (Effort/Schedule)  = 3.40
Total Estimated Cost to Develop                           = $ 355,287
 (average salary = $56,286/year, overhead = 2.40).
</pre></div><p>generated using David A. Wheeler's <a href="http://www.dwheeler.com/sloccount/">SLOCCount</a> version 2.26</p>
<hr/>
<h2><a class="anchor" id="othersoft">
Other micromagnetics software</a></h2>
<p>Here are a few links to other free and commercial micromagnetics packages:</p>
<ul>
<li><a href="http://math.nist.gov/oommf/">OOMMF (Object Oriented MicroMagnetic Framework)</a></li>
<li><a href="http://nmag.soton.ac.uk/">nmag - a flexbile micromagnetic simulation package</a></li>
<li><a href="http://jamm.uno.edu/">JaMM - Java MicroMagnetics</a></li>
<li><a href="http://www.rkmag.com">RKMAG</a></li>
<li><a href="http://llgmicro.home.mindspring.com/">LLG Micromagnetics Simulator</a></li>
<li><a href="http://www.micromagus.de/">MicroMagus</a></li>
<li><a href="http://www.magoasis.com/">MagOasis</a></li>
<li><a href="http://www.firmasuess.at/">FEMME - multiscale finite element micromagnetic package</a></li>
<li><a href="http://math.nist.gov/oommf/contrib/simulmag/">PC Micromagnetics Simulator</a></li>
<li><a href="http://faculty.mint.ua.edu/~visscher/AlaMag/">AlaMag</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="oldlibs">
Installation of old library versions</a></h2>
<h3><a class="anchor" id="c_mpich1">
MPICH1</a></h3>
<div class="fragment"><pre class="fragment">
  cd $PD
  wget ftp://ftp.mcs.anl.gov/pub/mpi/mpich.tar.gz
  tar xzvf mpich.tar.gz
  cd mpich-1.2.6
  # patch -p0 &lt; ../patchfile
  #  if you experience problems applying the patch
  #  go back to the original mpich.tar.gz
  ./configure
  make
  make testing
  # Problems with RedHat 6.2 bash: testing fails
  # solution: replace bash version 1 with version 2:
  # cd /bin; mv bash bash.bak; ln -s bash2 bash
  #
  # install the binaries in $PD/mpich
  ./bin/mpiinstall -prefix=$PD/mpich
  # set symbolic link to MPICH installation directory
  cd $PD
  ln -s mpich mpi
</pre></div><h3><a class="anchor" id="c_lam">
LAM/MPI</a></h3>
<div class="fragment"><pre class="fragment">
  cd $PD
  wget http://www.lam-mpi.org/download/files/lam-7.1.2.tar.gz
  tar xzvf lam-7.1.2.tar.gz
  cd lam-7.1.2
  ./configure --prefix=$PD/lam
  make
  make install
  # set symbolic link to LAM installation directory
  cd $PD
  ln -s lam mpi
  # start LAM universe on local machine:
  lamboot -v
</pre></div><hr/>
<h2><a class="anchor" id="bmatsize">
How does boundary matrix size scale with mesh length?</a></h2>
<p>Since the boundary matrix contains one row and one column for every surface node, it is clear that <img class="formulaInl" alt="$\textrm{boundary matrix size} \sim (\textrm{number of surface nodes})^2$" src="form_0.png"/>.</p>
<p>The surface of the mesh consists of triangles, edges, and points: </p>
<div align="center">
<img src="mesh_surface.png" alt="mesh_surface.png"/>
<p><strong>2D surface of a 3D tetrahedral mesh</strong></p></div>
<p> Their numbers are: </p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\begin{eqnarray*} t &amp; = &amp; \textrm{number of triangles} \\ e &amp; = &amp; \textrm{number of edges} = \frac{3}{2}t \quad\quad\textrm{(3 edges/triangle, each shared by exactly two triangles)} \\ n &amp; = &amp; \textrm{number of nodes} \end{eqnarray*}" src="form_1.png"/>
</p>
<p>If the mesh is a continuous, perfect simple hexagonal mesh, then each node is shared by six triangles. There are three nodes per triangle and thus:</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\begin{eqnarray*} n &amp;=&amp; (\textrm{number of triangles}) \times (\textrm{number of nodes/triangle}) / (\textrm{number of triangles sharing each node}) \\ &amp;=&amp; t \times 3 / 6 \\ &amp;=&amp; \frac{t}{2} \end{eqnarray*}" src="form_2.png"/>
</p>
<p>Consider the process of subdividing every triangle into four smaller triangles. This is what Magpar does when the <code>-refine 1</code> option is given, and is effectively the same as reducing the mesh length by a factor of 2:</p>
<div align="center">
<img src="mesh_refine.png" alt="mesh_refine.png"/>
<p><strong>The effect of -refine 1 on a surface mesh</strong></p></div>
<p> How are <img class="formulaInl" alt="$e_f$" src="form_3.png"/>, <img class="formulaInl" alt="$t_f$" src="form_4.png"/>, <img class="formulaInl" alt="$n_f$" src="form_5.png"/> related to <img class="formulaInl" alt="$e_0$" src="form_6.png"/>, <img class="formulaInl" alt="$t_0$" src="form_7.png"/>, <img class="formulaInl" alt="$n_0$" src="form_8.png"/>? </p>
<ol>
<li>
every triangle becomes four new triangles, thus <img class="formulaInl" alt="$tf=4t_0$" src="form_9.png"/> </li>
<li>
a new node is placed along every edge, thus <img class="formulaInl" alt="$n_f=n_0+e_0$" src="form_10.png"/> </li>
</ol>
<p>Since <img class="formulaInl" alt="$e=\frac{3}{2}t$" src="form_11.png"/>, we get <span style="background-color: yellow"><img class="formulaInl" alt="$n_f=n_0+\frac{3}{2}t_0$" src="form_12.png"/></span>.</p>
<p><b>In the case of a simple hexagonal mesh:</b> <img class="formulaInl" alt="$t=2n$" src="form_13.png"/>, thus <img class="formulaInl" alt="$n_f=n_0+3n_0$" src="form_14.png"/>, or <img class="formulaInl" alt="$n_f=4n_0$" src="form_15.png"/>. In this case, <img class="formulaInl" alt="$n \sim (\textrm{mesh length})^{-2}$" src="form_16.png"/>.</p>
<p>This is <b>neither an upper bound nor a lower bound</b>, since it is possible for there to be more than 6 triangles sharing each surface on average, or less than 6 on average. But most of the non-hexagonal cases I can think of are pretty pathological, and a quick glance at a mesh produced by Gmsh shows that surface nodes overwhelmingly are shared by 6 triangles.</p>
<p>From this we conclude that <img class="formulaInl" alt="$n \sim (\textrm{mesh length})^{-2}$" src="form_16.png"/> to an excellent approximation. Since <img class="formulaInl" alt="$(\textrm{boundary matrix size}) \sim (\textrm{number of surface nodes})^{2}$" src="form_17.png"/>, we conclude that: <img class="formulaInl" alt="$(\textrm{boundary matrix size}) \sim (\textrm{mesh length})^{-4}$" src="form_18.png"/></p>
<hr/>
<h2><a class="anchor" id="barycentric">
Interpolating in a tetrahedral mesh with barycentric coordinates</a></h2>
<p>Barycentric coordinates are ideal for interpolation within a tetrahedral finite-element mesh (such as used by Magpar). Barycentric interpolation expresses the interpolated function as a weighted sum of the function's values at the four vertices of the tetrahedral cell in which the interpolation point lies. Basically, it assumes linearity of the function within the cell:</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[ f(\vec{x}) = f \left( \sum_{k=1}^4 \lambda_k \vec{v}_k \right) = \sum_{k=1}^4 \lambda_k f(\vec{v}_k) \quad\forall\; \vec{x} \in \textrm{ the tetrahedral volume with vertices } \vec{v}_1 ... \vec{v}_4 \]" src="form_19.png"/>
</p>
<div align="center">
<img src="barycentric_2D_3D.png" alt="barycentric_2D_3D.png"/>
<p><strong>Barycentric coordinates on 2D and 3D simplices (triangles and tetrahedra)</strong></p></div>
<p> From this basic description, we infer: </p>
<ul>
<li>
The sum of the <img class="formulaInl" alt="$n$" src="form_20.png"/> barycentric coordinates, denoted <img class="formulaInl" alt="$\lambda_{1...n}$" src="form_21.png"/>, is exactly 1. </li>
<li>
For any point on the surface/perimeter, <img class="formulaInl" alt="$\lambda_i=0$" src="form_22.png"/> for at least one <img class="formulaInl" alt="$i$" src="form_23.png"/>. </li>
<li>
For any point within the volume/area, <img class="formulaInl" alt="$0 < \lambda_i < 1 \;\forall\; i$" src="form_24.png"/>. </li>
</ul>
<p>Given the linearity of this coordinate system, there must be a matrix <img class="formulaInl" alt="$A$" src="form_25.png"/> that will transform from barycentric coordinates to Cartesian coordinates, that is <img class="formulaInl" alt="$A\cdot\vec{\lambda}=\vec{x}$" src="form_26.png"/>. For the 3D case, <img class="formulaInl" alt="$\vec x$" src="form_27.png"/> is 3D and <img class="formulaInl" alt="$\vec\lambda$" src="form_28.png"/> is 4D, thus <img class="formulaInl" alt="$A$" src="form_25.png"/> is  3&times;4.</p>
<p>We know how A maps the tetrahedron's vertices to barycentric coordinates:</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[ A \left( \begin{array}{c}1\\0\\0\\0\end{array} \right) = \vec{v}_1, \quad A \left( \begin{array}{c}0\\1\\0\\0\end{array} \right) = \vec{v}_2, \quad A \left( \begin{array}{c}0\\0\\1\\0\end{array} \right) = \vec{v}_3, \quad A \left( \begin{array}{c}0\\0\\0\\1\end{array} \right) = \vec{v}_4, \quad \]" src="form_29.png"/>
</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[ \textrm{thus} \quad AI = A = \left(\begin{array}{cccc} v_{1x} &amp; v_{2x} &amp; v_{3x} &amp; v_{4x} \\ v_{1y} &amp; v_{2y} &amp; v_{3y} &amp; v_{4y} \\ v_{1z} &amp; v_{2z} &amp; v_{3z} &amp; v_{4z} \end{array}\right) \]" src="form_30.png"/>
</p>
<p>So far so good, we can map barycentric coordinates to tetrahedral vertices. However, the reverse isn't there yet. We need to recall the additional constraint on the sum of the barycentric coordinates:</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[\sum_{k=1}^4 \lambda_k = 1\]" src="form_31.png"/>
</p>
<p>We can combine this with the matrix <img class="formulaInl" alt="$A$" src="form_25.png"/> to get:</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[ T\vec\lambda = \left(\begin{array}{c}x\\y\\z\\1\end{array}\right) \quad\textrm{where}\quad T=\left(\begin{array}{cccc} v_{1x} &amp; v_{2x} &amp; v_{3x} &amp; v_{4x} \\ v_{1y} &amp; v_{2y} &amp; v_{3y} &amp; v_{4y} \\ v_{1z} &amp; v_{2z} &amp; v_{3z} &amp; v_{4z} \\ 1 &amp; 1 &amp; 1 &amp; 1 \end{array}\right), \quad\textrm{and thus}\quad \vec\lambda=T^{-1}\left(\begin{array}{c}x\\y\\z\\1\end{array}\right) \]" src="form_32.png"/>
</p>
<p>Now the inverse matrix, <img class="formulaInl" alt="$T^{-1}$" src="form_33.png"/>, maps from Cartesian coordinates to barycentric coordinates. Here's the complete algorithm to do barycentric interpolation of a point <img class="formulaInl" alt="$\vec{x}$" src="form_34.png"/> within a tetrahedral mesh:</p>
<ol>
<li>
<p class="startli">Compute the barycentric coordinate transformation matrices <img class="formulaInl" alt="$T$" src="form_35.png"/> for all the (nearby) cells in the mesh, and invert them to get <img class="formulaInl" alt="$T^{-1}$" src="form_33.png"/>.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">For each cell and interpolation point, compute <img class="formulaInl" alt="$\vec\lambda=T^{-1}\vec{x}$" src="form_36.png"/>.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">For each <img class="formulaInl" alt="$x$" src="form_37.png"/>, there will only be at most one <img class="formulaInl" alt="$i$" src="form_23.png"/> such that <img class="formulaInl" alt="$0 < \lambda_k < 1$" src="form_38.png"/> for <img class="formulaInl" alt="$k=1...4$" src="form_39.png"/>. If point <img class="formulaInl" alt="$\vec{x}$" src="form_34.png"/> lies on the surface of a tetrahedron, there may be several choices with <img class="formulaInl" alt="$0 \leq \lambda_k \leq 1$" src="form_40.png"/>. Pick any one.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Now we know (a)&nbsp;which cell <img class="formulaInl" alt="$\vec x$" src="form_27.png"/> is in, (b)&nbsp;its barycentric coordinates <img class="formulaInl" alt="$\vec\lambda$" src="form_28.png"/> relative to that cell, and (c)&nbsp;the vertices <img class="formulaInl" alt="$\vec v_1$" src="form_41.png"/>, <img class="formulaInl" alt="$\vec v_2$" src="form_42.png"/>, <img class="formulaInl" alt="$\vec v_3$" src="form_43.png"/>, and <img class="formulaInl" alt="$\vec v_4$" src="form_44.png"/> of that cell. Now it's easy: the interpolated function at point <img class="formulaInl" alt="$\vec x$" src="form_27.png"/> is simply the <img class="formulaInl" alt="$\vec\lambda$" src="form_28.png"/>-weighted average of the function's value at the vertices,</p>
<p class="formulaDsp">
<img class="formulaDsp" alt="\[ f_\textrm{interp}(\vec x)= \sum_{k=1}^{4} \lambda_k f(\vec v_k) \]" src="form_45.png"/>
</p>
  </li>
</ol>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

